import { MessageSyntaxError } from '../errors.js';
import type * as CST from './cst-types.js';
export declare class ParseContext {
    readonly errors: MessageSyntaxError[];
    readonly resource: boolean;
    readonly source: string;
    constructor(source: string, opt?: {
        resource?: boolean;
    });
    onError(type: Exclude<typeof MessageSyntaxError.prototype.type, 'missing-char'>, start: number, end: number): void;
    onError(type: 'missing-char', start: number, char: string): void;
}
/**
 * Parse the string syntax representation of a message into
 * its corresponding CST representation.
 *
 * @beta
 */
export declare function parseMessage(source: string, opt?: {
    resource?: boolean;
}): CST.Message;
