export declare class MessageError extends Error {
    type: 'missing-func' | 'not-formattable' | typeof MessageResolutionError.prototype.type | typeof MessageSelectionError.prototype.type | typeof MessageSyntaxError.prototype.type;
    constructor(type: typeof MessageError.prototype.type, message: string);
}
export declare class MessageSyntaxError extends MessageError {
    type: 'empty-token' | 'bad-escape' | 'bad-local-var' | 'bad-selector' | 'extra-content' | 'key-mismatch' | 'parse-error' | 'missing-char' | 'missing-fallback';
    start: number;
    end: number;
    char?: string;
    constructor(type: typeof MessageSyntaxError.prototype.type, start: number, end: number, char?: string);
}
export declare class MissingCharError extends MessageSyntaxError {
    char: string;
    constructor(pos: number, char: string);
}
export declare class MessageDataModelError extends MessageSyntaxError {
    type: 'key-mismatch' | 'missing-fallback';
}
export declare class MessageResolutionError extends MessageError {
    type: 'bad-input' | 'bad-option' | 'reserved' | 'unresolved-var';
    source: string;
    constructor(type: typeof MessageResolutionError.prototype.type, message: string, source: string);
}
export declare class MessageSelectionError extends MessageError {
    type: 'no-match' | 'not-selectable';
    constructor(type: typeof MessageSelectionError.prototype.type);
}
