import type { Message } from '../data-model';
import type { MessageFunctions } from '../runtime';
/**
 * Validate a message.
 *
 * @remarks
 * Throws if `msg` is not a pattern or select message,
 * or if it references runtime functions that are not available in the `functions`.
 *
 * Formatting a message that passes validation may still fail,
 * as it may depend on parameters that are not passed in,
 * or its runtime function calls may fail.
 *
 * @beta
 */
export declare function validate(msg: Readonly<Message>, functions: MessageFunctions): void;
