import type { Context } from '../format-context';
import type { MessageValue } from '../runtime';
import { FunctionRef } from './function-ref';
import { Literal } from './literal';
import { Reserved } from './reserved';
import { VariableRef } from './variable-ref';
export { isFunctionRef, FunctionRef, Option } from './function-ref';
export { isLiteral, isText, Literal, Text } from './literal';
export { isReserved, Reserved } from './reserved';
export { getMessageValue, isVariableRef, UnresolvedExpression, VariableRef } from './variable-ref';
/**
 * Wrapper for selectors and placeholders.
 *
 * @beta
 */
export interface Expression {
    type: 'expression';
    body: Literal | VariableRef | FunctionRef | Reserved;
}
/**
 * Type guard for {@link Expression} pattern elements
 *
 * @beta
 */
export declare const isExpression: (part: any) => part is Expression;
/** @internal */
export declare function resolveExpression(ctx: Context, { body }: Expression): MessageValue;
