"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveExpression = exports.isExpression = exports.UnresolvedExpression = exports.isVariableRef = exports.getMessageValue = exports.isReserved = exports.isText = exports.isLiteral = exports.isFunctionRef = void 0;
const function_ref_1 = require("./function-ref");
const literal_1 = require("./literal");
const reserved_1 = require("./reserved");
const variable_ref_1 = require("./variable-ref");
var function_ref_2 = require("./function-ref");
Object.defineProperty(exports, "isFunctionRef", { enumerable: true, get: function () { return function_ref_2.isFunctionRef; } });
var literal_2 = require("./literal");
Object.defineProperty(exports, "isLiteral", { enumerable: true, get: function () { return literal_2.isLiteral; } });
Object.defineProperty(exports, "isText", { enumerable: true, get: function () { return literal_2.isText; } });
var reserved_2 = require("./reserved");
Object.defineProperty(exports, "isReserved", { enumerable: true, get: function () { return reserved_2.isReserved; } });
var variable_ref_2 = require("./variable-ref");
Object.defineProperty(exports, "getMessageValue", { enumerable: true, get: function () { return variable_ref_2.getMessageValue; } });
Object.defineProperty(exports, "isVariableRef", { enumerable: true, get: function () { return variable_ref_2.isVariableRef; } });
Object.defineProperty(exports, "UnresolvedExpression", { enumerable: true, get: function () { return variable_ref_2.UnresolvedExpression; } });
/**
 * Type guard for {@link Expression} pattern elements
 *
 * @beta
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const isExpression = (part) => !!part && typeof part === 'object' && part.type === 'expression';
exports.isExpression = isExpression;
/** @internal */
function resolveExpression(ctx, { body }) {
    switch (body.type) {
        case 'literal':
            return (0, literal_1.resolveLiteral)(ctx, body);
        case 'variable':
            return (0, variable_ref_1.resolveVariableRef)(ctx, body);
        case 'function':
            return (0, function_ref_1.resolveFunctionRef)(ctx, body);
        case 'reserved':
            return (0, reserved_1.resolveReserved)(ctx, body);
        default:
            // @ts-expect-error - should never happen
            throw new Error(`Unsupported expression: ${body.type}`);
    }
}
exports.resolveExpression = resolveExpression;
