"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveLiteral = exports.isText = exports.isLiteral = void 0;
const index_js_1 = require("../runtime/index.js");
/**
 * Type guard for {@link Literal} pattern elements
 *
 * @beta
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const isLiteral = (part) => !!part && typeof part === 'object' && part.type === 'literal';
exports.isLiteral = isLiteral;
/**
 * Type guard for {@link Text} pattern elements
 *
 * @beta
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const isText = (part) => !!part && typeof part === 'object' && part.type === 'text';
exports.isText = isText;
function resolveLiteral(ctx, lit) {
    const msgCtx = new index_js_1.MessageFunctionContext(ctx, `|${lit.value}|`);
    return ctx.functions.string(msgCtx, {}, lit.value);
}
exports.resolveLiteral = resolveLiteral;
