"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveReserved = exports.isReserved = void 0;
const errors_js_1 = require("../errors.js");
const index_js_1 = require("../runtime/index.js");
const value_js_1 = require("./value.js");
/**
 * Type guard for {@link Reserved} pattern elements
 *
 * @beta
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const isReserved = (part) => !!part && typeof part === 'object' && part.type === 'reserved';
exports.isReserved = isReserved;
function resolveReserved(ctx, { operand, sigil, source }) {
    const msg = `Reserved ${sigil} expression is not supported`;
    ctx.onError(new errors_js_1.MessageResolutionError('reserved', msg, source));
    return (0, index_js_1.fallback)((0, value_js_1.getValueSource)(operand) ?? source);
}
exports.resolveReserved = resolveReserved;
