"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getValueSource = exports.resolveValue = void 0;
const variable_ref_1 = require("./variable-ref");
/** @internal */
function resolveValue(ctx, value) {
    switch (value.type) {
        case 'literal':
            return value.value;
        case 'variable':
            return (0, variable_ref_1.lookupVariableRef)(ctx, value);
        default:
            // @ts-expect-error - should never happen
            throw new Error(`Unsupported value: ${value.type}`);
    }
}
exports.resolveValue = resolveValue;
/** @internal */
function getValueSource(value) {
    switch (value?.type) {
        case 'literal':
            return '|' + value.value + '|';
        case 'variable':
            return '$' + value.name;
        default:
            return undefined;
    }
}
exports.getValueSource = getValueSource;
