import type { MessageExpressionPart, MessageValue } from './index.js';
export interface MessageMarkup extends MessageValue {
    readonly type: 'open' | 'close';
    readonly source: string;
    readonly locale: 'und';
    readonly name: string;
    readonly options: Record<string, unknown>;
    toParts(): [MessageMarkupPart];
    toString(): '';
    valueOf?: () => unknown;
}
export interface MessageMarkupPart extends MessageExpressionPart {
    type: 'open' | 'close';
    source: string;
    name: string;
    value?: unknown;
    options?: {
        [key: string]: unknown;
    };
}
export declare function markup(source: string, type: 'open' | 'close', name: string, options?: Record<string, unknown>, input?: unknown): MessageMarkup;
