"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.markup = void 0;
function getValue(value) {
    if (typeof value === 'object' && typeof value?.valueOf === 'function') {
        const vv = value.valueOf();
        if (vv !== value)
            return vv;
    }
    return value;
}
function markup(source, type, name, options, input) {
    const value = getValue(input);
    let opt;
    if (options) {
        opt = {};
        for (const [name, value] of Object.entries(options)) {
            opt[name] = getValue(value);
        }
    }
    const markup = {
        type: type,
        source,
        locale: 'und',
        name,
        get options() {
            return { ...opt };
        },
        toParts() {
            const part = { type, source, name };
            if (input !== undefined)
                part.value = value;
            if (opt)
                part.options = opt;
            return [part];
        },
        toString: () => ''
    };
    if (input !== undefined)
        markup.valueOf = () => value;
    return markup;
}
exports.markup = markup;
