import type { MessageExpressionPart, MessageFunctionContext, MessageValue } from './index.js';
export interface MessageString extends MessageValue {
    readonly type: 'string';
    readonly source: string;
    readonly locale: string;
    selectKey(keys: Set<string>): string | null;
    toParts(): [MessageStringPart];
    toString(): string;
    valueOf(): string;
}
export interface MessageStringPart extends MessageExpressionPart {
    type: 'string';
    source: string;
    locale: string;
    value: string;
}
export declare function string({ locales, source }: Pick<MessageFunctionContext, 'locales' | 'source'>, options: Record<string, unknown>, input?: unknown): MessageString;
